﻿using System;
using System.Linq;
using sly.parser.generator;

namespace lytest
{
    class Program
    {
        static void Main(string[] args)
        {
            var parserInstance = new RnLangNaiveParser();
            var builder = new ParserBuilder<RnLangNaiveParser.LexerTokens, RnLangNaiveParser.ExprClosure>();
            var parser = builder.BuildParser(parserInstance, ParserType.LL_RECURSIVE_DESCENT, "expr").Result;

            var r = parser.Parse("1+1");
            if (!r.IsError) 
            {
                Console.WriteLine($"result of <1+1>  is {r.Result.valueInt}");
                // outputs : result of <42 + 42>  is 84"
            }
            else
            {
                if (r.Errors !=null && r.Errors.Any())
                {
                    // display errors
                    r.Errors.ForEach(error => Console.WriteLine(error.ErrorMessage));
                }
            }

        }
    }
}